OPT OSVERSION=37
OPT PREPROCESS, REG=5

/*
 *-- AutoRev header do NOT edit!
 *
 *   Project         :   check volume validating (after bootup)
 *   File            :   valid.e
 *   Copyright       :    1996 by Piotr Gapinski
 *   Author          :   Piotr Gapinski
 *   Creation Date   :   12.02.96
 *   Current version :   1.0
 *   Translator      :   AmigaE v3.1+
 *
 *   REVISION HISTORY
 *
 *   Date         Version         Comment
 *   --------     -------         ------------------------------------------
 *
 *-- REV_END --*
 */

/*
   Program ma zapobiec mczarniom jakie przeywa stacja dyskw
 lub twardziel gdy podczas walidacji nosnika nastepuje jednoczenie
 dalszy odczyt danych.
 Wywoanie programu najlepiej umiecic w startup-sequence (ale nie
 przed setpatch) - spowoduje to, e w przypadku walidacji nonika
 wykonywanie skryptu startup-sequence zostanie wstrzymane do czasu
 zakoczenia procesu naprawy.
 UWAGA:
 autor nie bierze na siebie ADNEJ odpowiedzialnoci za ewentualne
 straty spowodowane dziaaniem programu.
*/

MODULE 'dos/dos','dos/dosextens'

#define PROGRAMVERSION '$VER: valid 1.0 (12.02.96) (c)Piotr Gapinski'

ENUM ARG_QUIET,NUMARGS
ENUM ERR_OK,ERR_KICK,ERR_ARGS,ERR_LIST,ERR_LOCK

PROC main() HANDLE
  DEF rdargs=0,args[NUMARGS]:LIST,quiet,
      name:PTR TO CHAR,str=NIL,
      dlock=0,dlist=NIL:PTR TO doslist,l,info:infodata,done

  IF KickVersion(37)=FALSE THEN Raise(ERR_KICK)
  IF (rdargs:=ReadArgs('QUIET/S',args,NIL))=NIL THEN Raise(ERR_ARGS)
  quiet:=IF args[ARG_QUIET] THEN TRUE ELSE FALSE
  dlist:=(dlock:=AttemptLockDosList(LDF_VOLUMES OR LDF_READ))
  IF dlock=NIL THEN Raise(ERR_LIST)

  WHILE dlist:=NextDosEntry(dlist,LDF_VOLUMES)
    IF dlist.type=DLT_VOLUME
      name:=BADDR(dlist.name)  -> BPRT TO BSTR
      str:=StrCopy(String(2+name[]++),name)
      StrAdd(str,':')
      IF (l:=Lock(str,ACCESS_READ))=NIL THEN Raise(ERR_LOCK)
      IF quiet=FALSE THEN WriteF('VOLUME: \l\s[20]  ',str)
      Info(l,info)
      IF info.diskstate=ID_VALIDATING
        IF quiet=FALSE THEN WriteF('VALIDATING...')
        REPEAT
          Info(l,info)
          done:=IF info.diskstate=ID_VALIDATING THEN FALSE ELSE TRUE
        UNTIL done
        IF quiet=FALSE THEN WriteF('DONE!\n')
      ELSE
        IF quiet=FALSE THEN WriteF('VALIDATED!\n')
      ENDIF
      UnLock(l)
    ENDIF
  ENDWHILE
EXCEPT DO
  IF rdargs<>NIL THEN FreeArgs(rdargs)
  IF dlock<>NIL THEN UnLockDosList(LDF_VOLUMES OR LDF_READ)
  IF exception THEN WriteF(ListItem(
    [
      'require kickstart v37+!\n',
      'bad args! (try "?")\n',
      'volumes list is allready locked!\n',
      'could not access volumes property!\n'
    ],
    exception-1))
ENDPROC

CHAR PROGRAMVERSION,0
